###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2005 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################

Name: fence
Version: 1.32.67
Release: 1%{?dist}.5
License: GPL
Group: System Environment/Base
Summary: fence - The cluster I/O fencing system
BuildRequires: cman-kernheaders ccs-devel
%ifnarch ppc64
BuildRequires: seamonkey-nss-devel seamonkey-nspr-devel
%endif
Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
Requires: seamonkey-nss
Requires: pexpect
Conflicts: GFS <= 6.0
Conflicts: GFS-modules
ExclusiveArch: i686 ia64 x86_64 ppc64
Source0: %{name}-%{version}.tar.gz
Patch0: fence-1.32.51-norun.patch
Patch1: bz562263.patch
Patch2: bz603765.patch
Patch3: xvm-strict-prototypes.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
The cluster I/O fencing system (fence) provides fencing agents which connect
to a variety of network power switch/fibre channel switches/etc. to forcibly
remove unresponsive machines from a cluster.

%prep
%setup -q
%patch0 -p1 -b .norun
%patch1 -p2 -b .bz562263
%patch2 -p2 -b .bz603765
%patch3 -p1 -b .xvm-strict-prototypes

%build
./configure --mandir=%{_mandir}
sed -i '/RELEASE_MAJOR/s/= .*/= 1/' make/defines.mk
sed -i '/RELEASE_MINOR/s/= .*/= 32.1/' make/defines.mk
sed -i '/RELEASE /s/= .*/= %version/' make/defines.mk
%ifarch ppc64
sed -i '/xvm/d' agents/Makefile
%endif
make

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/rc.d
mv -f $RPM_BUILD_ROOT/etc/init.d $RPM_BUILD_ROOT/etc/rc.d/

cp agents/scsi/scsi_reserve $RPM_BUILD_ROOT/etc/rc.d/init.d

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add fenced
/sbin/chkconfig --add scsi_reserve

%preun
if [ "$1" = 0 ]; then
        /sbin/chkconfig --del fenced
fi

%files
%defattr(-,root,root,-)
/sbin/*
/usr/share/cluster/README_SNMP
/usr/share/cluster/powernet369.mib
%config /etc/rc.d/init.d/fenced 
%config /etc/rc.d/init.d/scsi_reserve 
/usr/lib/fence/fencing.py
/usr/lib/fence/telnet_ssl

%{_mandir}/*/*

%changelog
* Mon Aug 16 2010 Chris Feist <cfeist@redhat.com>
- Replaced open3 calls (which can cause hangs) with qx for executing commands.
- Resolves: rhbz#603765

* Fri Feb 05 2010 Chris Feist <cfeist@redhat.com>
- Add power-wait option to solve ilo2 v1.70 problem
- Resolves: rhbz#562263

* Wed Apr 22 2009 Chris Feist <cfeist@redhat.com>
- Added support for Dell M600 CMC
- Resolves: rhbz#466788

* Wed Mar 18 2009 Chris Feist <cfeist@redhat.com>
- Fixed exceptions in fence agents.
- Resolves: rhbz#489670

* Fri Mar 06 2009 Chris Feist <cfeist@redhat.com>
- Add support for fence_egenera specifying the ssh login name
- Add support for LPAR/HMC v3
- WTI RPS-10 fence agent now does a reboot by default
- Open Firmware now properly reports status
- WTI fence agent now supports passwordless device
- Increased the number of IPMI retries
- APC SNMP fence device now properly recognizes outletStatusOff
- Resolves: rhbz#445931 rhbz#485065 rhbz#472885 rhbz#485075 rhbz#472370 rhbz#484910

* Mon Dec 08 2008 Chris Feist <cfeist@redhat.com>
- Fixed a fence storm with fence_egenera
- Added a restart option to the scsi_reserve init script
- Added fence agent for the ePowerSwitch 8M+ (fence_eps)
- Fixed typo in IPMI usage
- Man pages have been updated to describe ssh support
- fence_lpar agent has been updated to handle errors
- Resolves: rhbz#237266 rhbz#460288 rhbz#437867 rhbz#409381 rhbz#468051 rhbz#472371 rhbz#472370

* Mon Jul 21 2008 Chris Feist <cfeist@redhat.com>
- fence_apc_snmp no longer powers off an outlet if the command line contains
  an error.
- Resolves: rhbz#447414

* Wed Jun 04 2008 Chris Feist <cfeist@redhat.com>
- Removed ssh fence agents for stability.

* Mon Jun 02 2008 Chris Feist <cfeist@redhat.com>
- fence_apc is now able to use stacked apc units with multiple power switches
- Resolves: rhbz#446995

* Tue May 27 2008 Chris Feist <cfeist@redhat.com>
- fence_apc is now able to connect to an APC 7900 with ssh
- Resolves: rhbz#447378

* Tue May 20 2008 Chris Feist <cfeist@redhat.com>
- Support for APC MasterSwitch was re-added in python
- Added ssh support for bladecenter
- Fixed version/copyright generator issues with perl to python switch
- Resolves: rhbz#248609 rhbz#446995 rhbz#447432 rhbz#447434 rhbz#447437

* Wed May 14 2008 Chris Feist <cfeist@redhat.com>
- We now require pexpect (for ssh agents)
- Resolves: rhbz#446432

* Tue May 06 2008 Chris Feist <cfeist@redhat.com>
- Added support for the 24 port APC fencing device
- Resolves: rhbz#444615

* Mon Apr 29 2008 Chris Feist <cfeist@redhat.com>
- Added ssh fencing support
- Resolves: rhbz#248609

* Tue Apr 15 2008 Chris Feist <cfeist@redhat.com>
- Max devices has been increased from 4 to 8
- Resolves: rhbz#284701

* Mon Apr 07 2008 Chris Feist <cfeist@redhat.com>
- Removed watchdog from this script as it is no longer used
- fence_scsi and scsi_reserve no longer use the state file for tracking
  registered devices
- Resolves: rhbz#409391

* Mon Mar 24 2008 Chris Feist <cfeist@redhat.com>
- We no longer run the scsi_reserve init script by default
- Resolves: rhbz#420651

* Wed Mar 05 2008 Chris Feist <cfeist@redhat.com>
- Cluster ID and node ID are used for scsi reservation key instead of ip
  address
- fence_ilo can now recognize 'option="off"'
- Support has been added for LVM stripes and mirrors
- Resolves: rhbz#360681 rhbz#428243 rhbz#431002

* Thu Oct 11 2007 Chris Feist <cfeist@redhat.com>
- Fixed an issue with fence_xvm using dprintf which could cause corruption
- Resolves: rhbz#326531

* Mon Oct 01 2007 Chris Feist <cfeist@redhat.com>
- fence_egenera no longer fences a node during a crash dump
- fence_ilo is now able to detect the RIBCL version
- fence_mcdata now will work with newer switch models
- A timeout bug in fence_bullpap was fixed
- Resolves: rhbz#233428 rhbz#258161 rhbz#205638 rhbz#240115 rhbz#309261

* Thu Sep 13 2007 Chris Feist <cfeist@redhat.com>
- Potential crash in fenced has been fixed.
- Resolves: rhbz#258161

* Wed Aug 29 2007 Chris Feist <cfeist@redhat.com>
- fenced init script now exits with the proper return code
- Resolves: rhbz#265261

* Fri Aug 17 2007 Chris Feist <cfeist@redhat.com>
- Fence apc now supports linked switches
- fence_egenera script no longer fences nodes during crash dumps
- Resolves: rhbz#193064 rhbz#233428

* Tue Jun 05 2007 Chris Feist <cfeist@redhat.com>
- Added requires for seamonkey-nss

* Wed Jan 31 2007 Chris Feist <cfeist@redhat.com>
- Added support for ppc64.
- Added support for watchdog timers.

* Fri May 06 2005 Chris Feist <cfeist@redhat.com>
- Cleaned up spec file (bz #157031).

* Mon Dec 20 2004 Chris Feist <cfeist@redhat.com>
- Rebuild for with new sources.

* Mon Dec 13 2004 Chris Feist <cfeist@redhat.com>
- Rebuild for with new sources.

* Fri Dec 10 2004 Chris Feist <cfeist@redhat.com>
- Removing perl dependencies from fence to prevent RPM dependency nightmares.

* Thu Nov 18 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Mon Oct 25 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Sat Aug 14 2004 Jon Brassow <jbrassow@redhat.com>
- various bug fixes (new upstream sources)

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com> 
- build for i386 and x86_64 only

* Thu Jun 17 2004 Jon Brassow <jbrassow@redhat.com> 
- Initial build.
